unit BoxAPI;

Interface
Uses
  Windows,
  Types;

Function UpStr(Str: String): String;
Function StrAlloc(Size: Cardinal): PChar;
Procedure StrDispose(Str: PChar);
Function GetLSPath: String;
Function GetBoxFromWnd(Box: PBox; Wnd: Integer): PBox;
Function GetToken(Args: String;n: Byte): String;
Function CommandToken(Args: String;n: Byte): String;
Function Int2Str(Value: Integer): String;
Function Str2Int(S: string): Integer;
Function Str2Hex(Str: String): LongInt;

Procedure SetWindowRgnEx(hWnd: HWND; Rgn_0: HRGN);
//Procedure MergeRgn(Var Dest: HRGN; Rgn_1, Rgn_2:HRGN; xOffs, yOffs: Integer);
Function _TrackMouseEvent(var EventTrack: TTrackMouseEvent): Boolean; stdcall; external 'Comctl32.dll';

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Procedure RemoveHint(Wnd: HWND);
Procedure CreateCommandWnd;
Procedure DestroyCommandWnd;

Function GetFlag(Flags,Flag: Byte): Boolean;
Procedure SetFlag(Var Flags: Byte; Flag: Byte; State: Boolean);

Function LSExecute(Owner: Integer;szCommand: AnsiString;nShowCmd: boolean):integer; cdecl;
Function LoadLSImage (szImage, szFile: PChar): HBitmap; cdecl;
Function AddBangCommand(command: string; f: Pointer): Boolean; cdecl;
Function RemoveBangCommand(command: string): Boolean; cdecl;
Procedure GetLSBitmapSize(hBitmap: HBitmap;Var x, y: Integer); cdecl;
Function BitmapToRegion (hBmp: Integer;cTransparentColor, cTolerance: Integer;xoffset, yoffset: Integer): HRGN; cdecl;
Procedure VarExpansion(Var buffer: PChar;Const value: PChar); cdecl;
Function LCReadNextConfig(F: integer; szPrefix,szBuffer : Pchar; dwLength: integer): Boolean; cdecl;
Function LCOpen(szPath: PChar): Integer; cdecl;
Function LCClose(F: integer): Boolean; cdecl;

Implementation

function GetLitestepWnd:HWND; cdecl; external lsapidll;
procedure InitCommonControls; stdcall; external 'comctl32.dll';

Function Pot(b,e: integer):LongInt;
Begin
  If (e=0) then
    Pot := 1
  Else
    Pot := b * Pot(b,e-1);
End;

Function UpStr(Str: String): String;
Var
  Pos: Integer;
  UStr: String;
Begin
  UStr := Str;
  For Pos := 1 to length(UStr) Do
    if (UStr[pos] >= 'a') and (UStr[pos] <= 'z') then Dec(UStr[pos], 32);
  Result := UStr;
End;

Function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

Procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;

function StrLen(Str: PChar): Cardinal; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        MOV     EAX,0FFFFFFFEH
        SUB     EAX,ECX
        MOV     EDI,EDX
end;

function StrCopy(Dest, Source: PChar): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        MOV     EAX,EDI
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        POP     ESI
        POP     EDI
end;

Function GetLSPath: String;
Var
  PC: PChar;
  e: Integer;
Begin
  PC := StrAlloc(256);
  GetModuleFileName(GetWindowLong(FindWindow('TApplication', 'LiteStep'), GWL_HINSTANCE),PC,255);
  E := Length(PC);
  While ( PC[e] <> '\' )AND( E > 0 ) Do Dec(E);
    Result := Copy(PC,1,e);
  StrDispose(PC)
End;

Function GetBoxFromWnd(Box: PBox; Wnd: Integer): PBox;
Begin
  If (Box^.Next_Box = nil) OR (Box^.hMainWnd = Wnd) then
    GetBoxFromWnd := Box
  Else
    GetBoxFromWnd := GetBoxFromWnd(Box^.Next_Box, Wnd);
End;

Function GetToken(Args: String;n: Byte): String;
Var
  a,e,i: Integer;
  c: Char;
Begin
  e:=1;C := #32;a:=0;
  For i:=1 to N do
  Begin
    If (c=#34) then inc(e);
    c := #32;
    While (Args[e]=c)DO Inc(e);
    If (Args[e]=#34) then Begin
      c := #34;inc(e);end;
    a:=e;
    While Not((Args[e]=c)OR(Args[e]=#0))DO Inc(e);
  End;
  If a<>e then
    Result := Copy(Args,a,e-a)
  else
    Result := '';
End;

Function CommandToken(Args: String;n: Byte): String;
Var
  a,e,i: Integer;
  c: Char;
Begin
  e:=1;C := #32;a:=0;
  Result := '';
  For i:=1 to N do
  Begin
    If (c=#34) then inc(e);
    c := #32;
    While (Args[e]=c)DO Inc(e);
    If (Args[e]=#34) then Begin
      c := #34;inc(e);end;
    a:=e;
    While Not((Args[e]=c)OR(Args[e]=#0))DO Inc(e);
  End;
  If a<>e then
    Result:=Copy(Args,a,255)
  else
    Result := '';
End;

Function Int2Str(Value: Integer): String;
Begin
  If not((Value DIV 10) = 0) then
    result := Int2Str(Value DIV 10) + Chr(48 + (Value MOD 10))
  else
    result := Chr(48 + (Value Mod 10));
end;

Function Str2Int(s: String): Integer;
Var
  i,c,v : integer;

Begin
  c := 0;v := 1;
  For i := length(s)-1 downto 0 do
    If ( s[i+1]='-' ) Then
      v := -1
    Else
      c := c + ( (ord(s[i+1])-48)*Pot(10,length(s)-i-1) );
  Str2Int := c*v;
End;

Function Str2Hex(Str: String): LongInt;

  Function Rek(Str: String; pos: Integer): LongInt;
  Var
    c: Char;
   Begin
     If Pos<>Length(Str) Then
     Begin
       C := Str[Length(Str)-pos];
       If (Ord(C)>47)AND(Ord(C)<58) Then
         Rek := Rek(Str,Pos+1)+((Ord(C)-48)*Pot(16,Pos))
       Else
         If (Ord(C)>64)AND(Ord(C)<71) Then
           Rek := Rek(Str,Pos+1)+((Ord(C)-55)*Pot(16,Pos)) ;
     End Else Rek := 0;
   End;

Begin
  Str2Hex := Rek(UpStr(Str),0);
End;

Procedure SetWindowRgnEx(hWnd: HWND; Rgn_0: HRGN);
Var
  windowRgn: HRGN;
Begin
  windowRgn := CreateRectRgn(0, 0, 0, 0);
  CombineRgn(windowRgn, Rgn_0, 0, RGN_COPY);
  SetWindowRgn(hWnd, windowRgn, true);
End;

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Const
  TTM_ADDTOOL = WM_USER + 4;
Var
  Ti: TToolInfo;
Begin
  If Hint_HWND=0 Then
  Begin
    InitCommonControls;
    Hint_HWND := CreateWindowEx(0,
       'Tooltips_class32', nil, TTS_ALWAYSTIP,
       CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
       CW_USEDEFAULT, 0, 0, hinstance, nil);
    If Hint_HWND=0 then
      MessageboxA(0,'Error Creating Tooltip Control',nil,0);
    SetWindowPos(Hint_HWND,HWND_TOPMOST,CW_USEDEFAULT,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE);
  end;
  Ti.cbSize := SizeOf(TToolInfo);
  Ti.uFlags := TTF_SUBCLASS;
  Ti.hInst := hInstance;
  Ti.hwnd := wnd;
  Ti.uId := 0;
  GetClientRect(Wnd, Ti.rect);
  Ti.lpszText := txt;
  SendMessage(Hint_HWND,TTM_ADDTOOL,0,Integer(@Ti))
End;

Procedure RemoveHint(Wnd: HWND);
Var
  Ti: TToolInfo;

Begin
  ti.cbSize := sizeof(TTOOLINFO);
  ti.uFlags := 0;
  ti.hwnd := Wnd;
  ti.hinst := hInstance;
  ti.uId := 0;
  ti.lpszText := Nil;
  SendMessage(Hint_HWND,TTM_DELTOOL,0,Integer(@Ti));
End;

Function Command_WndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Buffer: PChar;
Begin
  Command_WndProc := 0;
  Case Msg Of
     BM_COMMAND:
       LsExecute(0,PChar(lparam),false);
     LM_GETREVID:  // Get our revision for '!About detailed'
       begin
         Buffer:=PChar(lParam);
         if (wParam=0) then
         begin
           StrCopy(Buffer,PChar('LsBox.dll: '+Revision));
         end
         else if (wParam=1) then
         begin
           StrCopy(Buffer,revId);
         end
         else
         begin
           StrCopy(Buffer,'');
         end;
         result:=StrLen(Buffer);
      end;
     Else
       Command_WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure CreateCommandWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  If NOT GetClassInfo(Inst,'CommandClass',wc) then
  Begin
    FillChar(wc,sizeof(wc), #0);
    wc.lpfnWndProc := @Command_WndProc;
    wc.lpszClassName := 'CommandClass';
    wc.hInstance := Inst;
    RegisterClassA(wc);
  End;
  Command_HWND := CreateWindowExA(
      WS_EX_TOOLWINDOW,'CommandClass','',WS_POPUP,
      0,0,0,0,0,0,Inst,nil);

  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_REGISTERMESSAGE, Command_HWND, Integer(@Msgs));
End;

Procedure DestroyCommandWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_UNREGISTERMESSAGE, Command_HWND, Integer(@Msgs));
  DestroyWindow(Command_HWND);
  If GetClassInfo(Inst,'CommandClass',wc) then
    UnregisterClass('CommandClass',Inst);
End;

Function GetFlag(Flags,Flag: Byte): Boolean;
Begin
  GetFlag := (Flags AND Flag = Flag);
End;

Procedure SetFlag(Var Flags: Byte; Flag: Byte; State: Boolean);
Begin
  If State Then
    Flags := (Flags OR Flag)
  Else
    Flags := (Flags And Not Flag)
End;

Function LSExecute; external lsapidll;
Function LoadLSImage; external lsapidll;
Function AddBangCommand; external lsapidll;
Function RemoveBangCommand; external lsapidll;
Procedure GetLSBitmapSize; external lsapidll;
Function BitmapToRegion; external lsapidll;
Procedure VarExpansion; external lsapidll;
Function LCReadNextConfig; external lsapidll;
Function LCOpen; external lsapidll;
Function LCClose; external lsapidll;

End.