unit Modules;

// Version 1.2
// Made UnLoadModules recursive
// Version 1.l
// Fixed Crash-on-Recycle when a module wasn't loaded properly
// Version 1.0

interface
Uses
  BoxFiles,
  BoxAPI,
  Types,
  Windows;

Procedure LoadModules(Box: PBox);
Procedure UnLoadModules(Module: PModule);

implementation

Function ModuleWndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Begin
  Result := DefWindowProcA(Wnd,Msg,wParam,lParam);
End;

Procedure LoadModules(Box: PBox);
Var
  Buffer: String;
  Module: PModule;
  wc: TWndClass;
  
Begin
  //Box^.First_Module := nil;

  Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Module');
    While Buffer<>'' do
      Begin
        New(Module);

        Module^.Next_Module := Box^.First_Module;
        Box^.First_Module := Module;

        With Module^ Do
        Begin
          ModuleHandle := LoadLibrary( PChar(GetToken(Buffer,1) ));

          If ModuleHandle = 0 then
            ModuleHandle := LoadLibrary( PChar(LsPath+'\'+GetToken(Buffer,1) ));

          If ModuleHandle <> 0 then
          Begin

            initModule := GetProcAddress( ModuleHandle, 'initWharfModule' );
            quitModule := GetProcAddress( ModuleHandle, 'quitWharfModule' );

            initModule( Box^.hMainWnd, Inst,nil );

          End
          Else
            Messagebox(0,'Can''t load Module',nil,0);

        End;

        Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Module');
      End;
End;

Procedure UnLoadModules(Module: PModule);
Begin
 If ( Module<>nil) then
  With Module^ Do
  Begin
    If ModuleHandle <> 0 then
      Begin
        QuitModule(Inst);
        FreeLibrary(ModuleHandle);
      End;
      UnLoadModules(Next_Module);
      Dispose(Module);
  End;
End;

end.
