unit Types;

Interface
Uses
  Windows;

Const
  Revision = '2.3b'#0#0;
  revId = 'Id: LsBox.dpr,v 2.3b 2001/03/20 blkhawk'#0#0; // The Full ID.
  
  WM_CREATE = $0001;
  WM_DESTROY = $0002;
  WM_PAINT = $000F;
  WM_ERASEBKGND = $0014;
  WM_MOUSEMOVE = $0200;
  WM_LBUTTONDOWN = $0201;
  WM_LBUTTONUP = $0202;
  WM_RBUTTONUP = $0205;
  WM_RBUTTONDOWN = $0204;
  WM_SYSCOMMAND = $0112;
  WM_MOUSELEAVE = $02A3;
  WM_USER = $0400;
  BM_COMMAND = WM_USER+92;
  TME_LEAVE = $00000002;
  TTS_ALWAYSTIP = $01;
  TTF_SUBCLASS = $0010;
  TTM_DELTOOL = WM_USER + 5;
  LM_GETREVID = 9265;
  LM_REGISTERMESSAGE = 9263;
  LM_UNREGISTERMESSAGE = 9264;

  lsapidll = 'LsApi.dll';
  //Flags
  Moveing   = 1;
  NotSnappy = 2;
  Minimized = 4;
  Hidden    = 8; 


Type
 windowType=record
    Handle  :HWnd;
    Visible :Bool;
    Position:TRect;
  end;

  PwharfDataType= ^wharfDataType;
  wharfDataType= packed record
    borderSize      :Longint;
    pos             :Longint;
    winListSize     :Longint;
    winList         :^windowType;
    trayIconSize    :Longint;
    lm78Unit        :Longint;
    lm78MaxCPU      :Longint;
    lm78MaxMb       :Longint;
    lm78CPU         :Longint;
    taskBar         :Longint;
    msTaskBar       :Longint;
    taskBarFore     :Longint;
    taskBarBack     :Longint;
    taskbarText     :Longint;
    vwmVelocity     :Longint;
    autoHideWharf   :Longint;
    autoHideTaskBar :Longint;
    vwmDistance     :Longint;
    autoHideDelay   :Longint;
    showBeta        :Longint;
    usClock         :Longint;
    VWMNoGathering  :Longint;
    VWMNoAuto       :Longint;
    xmouseDelay     :Longint;
    xmouseBringToTop:Longint;
    pixmapDir       :PChar;
    defaultBmp      :PChar;
    vwmBackColor    :Longint;
    vwmSelBackColor :Longint;
    vwmForeColor    :Longint;
    vwmBorderColor  :Longint;
    backsaver       :PChar;
    taskBarFore2    :Longint;
    stripBar        :Longint;
    lsPath          :PChar;
  end;

  TTrackMouseEvent = record
    cbSize: DWORD;
    dwFlags: DWORD;
    hwndTrack: HWND;
    dwHoverTime: DWORD;
  end;

  //Toolinfo declaration for tooltips
  PToolInfo = ^TToolInfo;
  TToolInfo = packed record
    cbSize: UINT;
    uFlags: UINT;
    hwnd: HWND;
    uId: UINT;
    Rect: TRect;
    hInst: THandle;
    lpszText: PAnsiChar;
  end;

  TCutState = (Normal,Over,Click);

  PBox = ^TBox;

  //Module type declaration
  PWharfModule = ^TWharfModule;
  TWharfModule = Record
                   M_Wnd : HWND;
                   ModuleHandle: Integer;
                   InitModule : Function (Parent: HWND; inst: Integer; Wd: PWharfdataType):Integer; cdecl;
                   QuitModule : Procedure (inst: Integer); cdecl;
                   Next_Module: PWharfModule;
                 End;

  //Module type declaration
  PModule = ^TModule;
  TModule = Record
              ModuleHandle: Integer;
              InitModule : Function (Parent: HWND; inst: Integer; Cfg: PChar):Integer; cdecl;
              QuitModule : Procedure (inst: Integer); cdecl;
              Next_Module: PModule;
            End; 

  //Shortcut type declaration
  PShortcut = ^TShortcut;
  TShortcut = Record
                DC_0, DC_1, DC_2, DC_3: HDC;
                RGN_0, RGN_1, RGN_2, RGN_3: HRGN;
                Swnd, xPos, yPos,
                Height, Width: Integer;
                State: TCutState;
                Command: String;
                Next_Shortcut: PShortcut; //Pointer to the next shortcut
                FBox: PBox; //Pointer to the parent box
              End;

  //The Main config list
  TBox = Record
           BackDC: HDC;  //Background Memory Device Context
           hMainWnd: HWND; //Main window handle
           xPos, yPos, Height, Width: Integer;
           DragRect: TRect;
           LeftClickBang,
           RightClickBang,
           Title: String;
           Flags: Byte;
           First_Shortcut,
           First_Module,
           First_WharfModule: Pointer;
           Next_Box, Prev_Box: PBox; //Pointer to next Box element
           BoxPtr: Pointer;
         End;

Var
  //Globale Variabelen
  Parent_Wnd: HWND;
  Hint_HWND: HWND = 0; //global ToolTip Handler
  Command_HWND: HWND = 0; //global Command Handeling
  First_Box: Pointer = nil;
  xOffs, yOffs : Integer;
  LsPath: String;
  SnapRect: trect;
  Inst: longint;

Implementation

End.