unit WharfModules;

// Version 1.2
// Made UnLoadWharfModules recursive
// Version 1.l
// Fixed Crash-on-Recycle when a module wasn't loaded properly
// Version 1.0

interface
Uses
  BoxFiles,
  BoxAPI,
  Types,
  Windows;

Procedure LoadWharfModules(Box: PBox);
Procedure UnLoadWharfModules(Module: PWharfModule);

implementation

Function ModuleWndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Begin
  Result := DefWindowProcA(Wnd,Msg,wParam,lParam);
End;

Procedure LoadWharfModules(Box: PBox);
Var
  Buffer: String;
  WharfModule: PWharfModule;
  wdata: PwharfDataType;
  wc: TWndClass;
  
Begin
  //Box^.First_WharfModule := nil;
  
  Buffer := BoxReadNextConfig(Box^.BoxPtr,'*WharfModule');
    While buffer<>'' do
      Begin
        New(WharfModule);

        WharfModule^.Next_Module := Box^.First_WharfModule;
        Box^.First_WharfModule := WharfModule;

        With WharfModule^ Do
        Begin
          ModuleHandle := LoadLibrary( PChar(GetToken(Buffer,5) ));

          If ModuleHandle = 0 then
            ModuleHandle := LoadLibrary( PChar(LsPath+'\'+GetToken(Buffer,5) ));
            
          If ModuleHandle <> 0 then
          Begin

            initModule := GetProcAddress( ModuleHandle, 'initWharfModule' );
            quitModule := GetProcAddress( ModuleHandle, 'quitWharfModule' );

            New(wdata);
            wdata^.lsPath := PChar( LsPath );
            wdata^.pixmapDir := StrAlloc( 255 );
            //LSGetImagePath( wdata^.pixmapDir , 255 );
            wdata^.pos := 0;
            wdata^.borderSize := 0;
            wdata^.defaultBmp := '';
            //wdata^.vwmVelocity := Integer(Box^.BoxPtr);
            If NOT GetClassInfo( Inst, 'LsBoxModule', wc ) then
            Begin
              FillChar( wc,sizeof(wc), #0 );
              wc.lpfnWndProc := @ModuleWndProc;
              wc.lpszClassName := 'LsBoxModule';
              wc.hInstance := Inst;
              RegisterClassA( wc );
            End;

            M_Wnd := CreateWindowExA(
                       0,'LsBoxModule',nil,WS_CHILD,
                       Str2Int(GetToken(Buffer,1)),
                       Str2Int(GetToken(Buffer,2)),
                       Str2Int(GetToken(Buffer,3)),
                       Str2Int(GetToken(Buffer,4)),
                       Box^.hmainWnd,0,
                       Inst,nil );

            initModule( M_Wnd, Inst,wdata );

            SetWindowPos( M_Wnd,HWND_TOP,
                          0,0,0,0,SWP_SHOWWINDOW+SWP_NOMOVE+SWP_NOSIZE );

            StrDispose( wdata^.pixmapDir );
            Dispose( wdata );

          End
          Else
            Messagebox(0,'Can''t load Wharf Module',nil,0);

        End;

        Buffer := BoxReadNextConfig(Box^.BoxPtr,'*WharfModule');
      End;
End;

Procedure UnLoadWharfModules(Module: PWharfModule);
Begin
 If ( Module<>nil) then
  With Module^ Do
  Begin
    If ModuleHandle <> 0 then
      Begin
        QuitModule(Inst);
        FreeLibrary(ModuleHandle);
      End;
      UnLoadWharfModules(Next_Module);
      Dispose(Module);
  End;
End;

end.
